import { world, BlockPermutation, GameMode } from "@minecraft/server";

world.afterEvents.playerBreakBlock.subscribe(eventData => {
  const player = eventData.player;
  const itemUsed = eventData.itemStackBeforeBreak;
  const brokenBlock = eventData.brokenBlockPermutation;
  const playerEquippable = player.getComponent("equippable");
  const instantDiggableBlocks = [
    "minecraft:acacia_sapling",
    "minecraft:allium",
    "minecraft:azalea",
    "minecraft:azure_bluet",
    "minecraft:beetroot",
    "minecraft:birch_sapling",
    "minecraft:blue_orchid",
    "minecraft:brain_coral",
    "minecraft:brain_coral_fan",
    "minecraft:brown_mushroom",
    "minecraft:bubble_coral",
    "minecraft:bubble_coral_fan",
    "minecraft:carrots",
    "minecraft:cave_vines",
    "minecraft:cave_vines_body_with_berries",
    "minecraft:cave_vines_head_with_berries",
    "minecraft:cherry_sapling",
    "minecraft:coral_fan_dead",
    "minecraft:coral_fan_hang",
    "minecraft:coral_fan_hang2",
    "minecraft:coral_fan_hang3",
    "minecraft:cornflower",
    "minecraft:crimson_fungus",
    "minecraft:crimson_roots",
    "minecraft:dark_oak_sapling",
    "minecraft:dead_brain_coral",
    "minecraft:dead_brain_coral_fan",
    "minecraft:dead_bubble_coral",
    "minecraft:dead_bubble_coral_fan",
    "minecraft:dead_fire_coral",
    "minecraft:dead_fire_coral_fan",
    "minecraft:dead_horn_coral",
    "minecraft:dead_horn_coral_fan",
    "minecraft:dead_tube_coral",
    "minecraft:dead_tube_coral_fan",
    "minecraft:deadbush",
    "minecraft:decorated_pot",
    "minecraft:double_plant", // old name
    "minecraft:end_rod",
    "minecraft:fern",
    "minecraft:fire",
    "minecraft:fire_coral",
    "minecraft:fire_coral_fan",
    "minecraft:flowering_azalea",
    "minecraft:flower_pot",
    "minecraft:frog_spawn",
    "minecraft:honey_block",
    "minecraft:hanging_roots",
    "minecraft:horn_coral",
    "minecraft:horn_coral_fan",
    "minecraft:jungle_sapling",
    "minecraft:kelp",
    "minecraft:lily_of_the_valley",
    "minecraft:mangrove_propagule",
    "minecraft:melon_stem",
    "minecraft:nether_sprouts",
    "minecraft:nether_wart",
    "minecraft:oak_sapling",
    "minecraft:orange_tulip",
    "minecraft:oxeye_daisy",
    "minecraft:pink_petals",
    "minecraft:pink_tulip",
    "minecraft:pitcher_plant",
    "minecraft:poppy",
    "minecraft:potatoes",
    "minecraft:powered_comparator",
    "minecraft:powered_repeater",
    "minecraft:pumpkin_stem",
    "minecraft:red_flower", // old name
    "minecraft:red_mushroom",
    "minecraft:red_tulip",
    "minecraft:redstone_torch",
    "minecraft:redstone_wire",
    "minecraft:reeds",
    "minecraft:sea_pickle",
    "minecraft:seagrass",
    "minecraft:short_grass",
    "minecraft:slime",
    "minecraft:soul_fire",
    "minecraft:soul_torch",
    "minecraft:spore_blossom",
    "minecraft:spruce_sapling",
    "minecraft:sweet_berry_bush",
    "minecraft:tallgrass", // old name
    "minecraft:tnt",
    "minecraft:torch",
    "minecraft:torchflower",
    "minecraft:tube_coral",
    "minecraft:tube_coral_fan",
    "minecraft:trip_wire",
    "minecraft:tripwire_hook",
    "minecraft:twisting_vines",
    "minecraft:unlit_redstone_torch",
    "minecraft:unpowered_comparator",
    "minecraft:unpowered_repeater",
    "minecraft:warped_fungus",
    "minecraft:warped_roots",
    "minecraft:waterlily",
    "minecraft:weeping_vines",
    "minecraft:wheat",
    "minecraft:white_tulip",
    "minecraft:wither_rose",
    "minecraft:yellow_flower",
    "minecraft:tall_grass",
    "minecraft:large_fern",
    "minecraft:sunflower",
    "minecraft:lilac",
    "minecraft:rose_bush",
    "minecraft:peony"
  ]
  const customAxes = [
    "nicothekid:flint_axe"
  ]
  const axeDiggableBlocks = [
    "minecraft:acacia_button",
    "minecraft:acacia_door",
    "minecraft:acacia_double_slab",
    "minecraft:acacia_fence",
    "minecraft:acacia_fence_gate",
    "minecraft:acacia_hanging_sign",
    "minecraft:acacia_log",
    "minecraft:acacia_planks",
    "minecraft:acacia_pressure_plate",
    "minecraft:acacia_slab",
    "minecraft:acacia_stairs",
    "minecraft:acacia_standing_sign",
    "minecraft:acacia_trapdoor",
    "minecraft:acacia_wall_sign",
    "minecraft:acacia_wood",
    "minecraft:bamboo",
    "minecraft:bamboo_block",
    "minecraft:bamboo_button",
    "minecraft:bamboo_door",
    "minecraft:bamboo_double_slab",
    "minecraft:bamboo_fence",
    "minecraft:bamboo_fence_gate",
    "minecraft:bamboo_hanging_sign",
    "minecraft:bamboo_mosaic",
    "minecraft:bamboo_mosaic_double_slab",
    "minecraft:bamboo_mosaic_slab",
    "minecraft:bamboo_mosaic_stairs",
    "minecraft:bamboo_planks",
    "minecraft:bamboo_pressure_plate",
    "minecraft:bamboo_sapling",
    "minecraft:bamboo_slab",
    "minecraft:bamboo_stairs",
    "minecraft:bamboo_standing_sign",
    "minecraft:bamboo_trapdoor",
    "minecraft:bamboo_wall_sign",
    "minecraft:barrel",
    "minecraft:bee_nest",
    "minecraft:beehive",
    "minecraft:birch_button",
    "minecraft:birch_door",
    "minecraft:birch_double_slab",
    "minecraft:birch_fence",
    "minecraft:birch_fence_gate",
    "minecraft:birch_hanging_sign",
    "minecraft:birch_log",
    "minecraft:birch_planks",
    "minecraft:birch_pressure_plate",
    "minecraft:birch_slab",
    "minecraft:birch_stairs",
    "minecraft:birch_standing_sign",
    "minecraft:birch_trapdoor",
    "minecraft:birch_wall_sign",
    "minecraft:birch_wood",
    "minecraft:bookshelf",
    "minecraft:brown_mushroom_block",
    "minecraft:campfire",
    "minecraft:cartography_table",
    "minecraft:carved_pumpkin",
    "minecraft:cherry_button",
    "minecraft:cherry_door",
    "minecraft:cherry_double_slab",
    "minecraft:cherry_fence",
    "minecraft:cherry_fence_gate",
    "minecraft:cherry_hanging_sign",
    "minecraft:cherry_log",
    "minecraft:cherry_planks",
    "minecraft:cherry_pressure_plate",
    "minecraft:cherry_slab",
    "minecraft:cherry_stairs",
    "minecraft:cherry_standing_sign",
    "minecraft:cherry_trapdoor",
    "minecraft:cherry_wall_sign",
    "minecraft:cherry_wood",
    "minecraft:chest",
    "minecraft:chiseled_bookshelf",
    "minecraft:chorus_flower",
    "minecraft:chorus_plant",
    "minecraft:cocoa",
    "minecraft:composter",
    "minecraft:crafting_table",
    "minecraft:crimson_button",
    "minecraft:crimson_door",
    "minecraft:crimson_double_slab",
    "minecraft:crimson_fence",
    "minecraft:crimson_fence_gate",
    "minecraft:crimson_hanging_sign",
    "minecraft:crimson_hyphae",
    "minecraft:crimson_planks",
    "minecraft:crimson_pressure_plate",
    "minecraft:crimson_slab",
    "minecraft:crimson_stairs",
    "minecraft:crimson_standing_sign",
    "minecraft:crimson_stem",
    "minecraft:crimson_trapdoor",
    "minecraft:crimson_wall_sign",
    "minecraft:dark_oak_button",
    "minecraft:dark_oak_door",
    "minecraft:dark_oak_double_slab",
    "minecraft:dark_oak_fence",
    "minecraft:dark_oak_fence_gate",
    "minecraft:dark_oak_hanging_sign",
    "minecraft:dark_oak_log",
    "minecraft:dark_oak_planks",
    "minecraft:dark_oak_pressure_plate",
    "minecraft:dark_oak_slab",
    "minecraft:dark_oak_stairs",
    "minecraft:dark_oak_trapdoor",
    "minecraft:dark_oak_wood",
    "minecraft:darkoak_standing_sign",
    "minecraft:darkoak_wall_sign",
    "minecraft:daylight_detector",
    "minecraft:daylight_detector_inverted",
    "minecraft:fence", // old name
    "minecraft:fence_gate",
    "minecraft:fletching_table",
    "minecraft:jukebox",
    "minecraft:jungle_button",
    "minecraft:jungle_door",
    "minecraft:jungle_double_slab",
    "minecraft:jungle_fence",
    "minecraft:jungle_fence_gate",
    "minecraft:jungle_hanging_sign",
    "minecraft:jungle_log",
    "minecraft:jungle_planks",
    "minecraft:jungle_pressure_plate",
    "minecraft:jungle_slab",
    "minecraft:jungle_stairs",
    "minecraft:jungle_standing_sign",
    "minecraft:jungle_trapdoor",
    "minecraft:jungle_wall_sign",
    "minecraft:jungle_wood",
    "minecraft:ladder",
    "minecraft:lectern",
    "minecraft:lit_pumpkin",
    "minecraft:log", // old name
    "minecraft:log2", // old name
    "minecraft:loom",
    "minecraft:mangrove_button",
    "minecraft:mangrove_door",
    "minecraft:mangrove_double_slab",
    "minecraft:mangrove_fence",
    "minecraft:mangrove_fence_gate",
    "minecraft:mangrove_hanging_sign",
    "minecraft:mangrove_log",
    "minecraft:mangrove_planks",
    "minecraft:mangrove_pressure_plate",
    "minecraft:mangrove_roots",
    "minecraft:mangrove_slab",
    "minecraft:mangrove_stairs",
    "minecraft:mangrove_standing_sign",
    "minecraft:mangrove_trapdoor",
    "minecraft:mangrove_wall_sign",
    "minecraft:mangrove_wood",
    "minecraft:melon_block",
    "minecraft:noteblock",
    "minecraft:oak_double_slab",
    "minecraft:oak_fence",
    "minecraft:oak_hanging_sign",
    "minecraft:oak_log",
    "minecraft:oak_planks",
    "minecraft:oak_slab",
    "minecraft:oak_stairs",
    "minecraft:oak_wood",
    "minecraft:pumpkin",
    "minecraft:red_mushroom_block",
    "minecraft:smithing_table",
    "minecraft:soul_campfire",
    "minecraft:spruce_button",
    "minecraft:spruce_door",
    "minecraft:spruce_double_slab",
    "minecraft:spruce_fence",
    "minecraft:spruce_fence_gate",
    "minecraft:spruce_hanging_sign",
    "minecraft:spruce_log",
    "minecraft:spruce_planks",
    "minecraft:spruce_pressure_plate",
    "minecraft:spruce_slab",
    "minecraft:spruce_stairs",
    "minecraft:spruce_standing_sign",
    "minecraft:spruce_trapdoor",
    "minecraft:spruce_wall_sign",
    "minecraft:spruce_wood",
    "minecraft:standing_banner",
    "minecraft:standing_sign",
    "minecraft:stripped_acacia_log",
    "minecraft:stripped_acacia_wood",
    "minecraft:stripped_bamboo_block",
    "minecraft:stripped_birch_log",
    "minecraft:stripped_birch_wood",
    "minecraft:stripped_cherry_log",
    "minecraft:stripped_cherry_wood",
    "minecraft:stripped_crimson_hyphae",
    "minecraft:stripped_crimson_stem",
    "minecraft:stripped_dark_oak_log",
    "minecraft:stripped_dark_oak_wood",
    "minecraft:stripped_jungle_log",
    "minecraft:stripped_jungle_wood",
    "minecraft:stripped_mangrove_log",
    "minecraft:stripped_mangrove_wood",
    "minecraft:stripped_oak_log",
    "minecraft:stripped_oak_wood",
    "minecraft:stripped_spruce_log",
    "minecraft:stripped_spruce_wood",
    "minecraft:stripped_warped_hyphae",
    "minecraft:stripped_warped_stem",
    "minecraft:trapdoor",
    "minecraft:trapped_chest",
    "minecraft:vine",
    "minecraft:wall_banner",
    "minecraft:wall_sign",
    "minecraft:warped_button",
    "minecraft:warped_door",
    "minecraft:warped_double_slab",
    "minecraft:warped_fence",
    "minecraft:warped_fence_gate",
    "minecraft:warped_hanging_sign",
    "minecraft:warped_hyphae",
    "minecraft:warped_planks",
    "minecraft:warped_pressure_plate",
    "minecraft:warped_slab",
    "minecraft:warped_stairs",
    "minecraft:warped_standing_sign",
    "minecraft:warped_stem",
    "minecraft:warped_trapdoor",
    "minecraft:warped_wall_sign",
    "minecraft:wooden_button",
    "minecraft:wooden_door",
    "minecraft:wooden_pressure_plate"
  ]
  if (itemUsed === undefined || player.matches({ gameMode: GameMode.creative })) return;
  if (customAxes.includes(itemUsed.typeId)) {
    if (!instantDiggableBlocks.includes(brokenBlock.type.id) && !brokenBlock.hasTag("instant_diggable")) {
      if (customAxes.includes(itemUsed.typeId)) {
        const itemEnchantable = itemUsed.getComponent("enchantable");
        const unbreakingLevel = itemEnchantable?.getEnchantment("unbreaking")?.level ?? 0;
        const breakChance = 100 / (unbreakingLevel + 1);
        const randomizeChance = Math.random() * 100;
        if (breakChance < randomizeChance) return;
        const itemDurability = itemUsed.getComponent("durability");
        if (!itemDurability) return;
        const itemMaxDurability = itemDurability.maxDurability;
        const itemDurabilityDamage = itemDurability.damage;
        const durabilityCalculation = itemMaxDurability - itemDurabilityDamage;
        let damageAmount = 0;
        if (axeDiggableBlocks.includes(brokenBlock.type.id) || brokenBlock.hasTag("axe_diggable") || brokenBlock.hasTag("wood")) {
          damageAmount = 1;
        }
        else {
          damageAmount = 2;
        };
        const currentDurability = durabilityCalculation - damageAmount;
        if (currentDurability <= 0) {
          player.playSound("random.break", { pitch: 0.9, location: player.location, volume: 1 });
          playerEquippable.setEquipment("Mainhand", null);
        }
        else {
          itemDurability.damage += damageAmount;
          playerEquippable.setEquipment("Mainhand", itemUsed)
        }
      }
    }
    else return;
  }
  else return;
});